'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

require('babel-polyfill');

var _isomorphicFetch = require('isomorphic-fetch');

var _isomorphicFetch2 = _interopRequireDefault(_isomorphicFetch);

require('source-map-support/register');

var _getCsv = require('get-csv');

var _getCsv2 = _interopRequireDefault(_getCsv);

require('date-format-lite');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Awin = function () {
	function Awin(_ref) {
		var oAuthToken = _ref.oAuthToken;
		(0, _classCallCheck3.default)(this, Awin);
		this.oAuthToken = null;

		this.oAuthToken = oAuthToken;
	}

	(0, _createClass3.default)(Awin, [{
		key: 'fetchJson',
		value: function fetchJson(url) {
			return (0, _isomorphicFetch2.default)(url, {
				headers: {
					'Authorization': 'Bearer ' + this.oAuthToken
				}
			}).then(function (response) {
				if (!response.ok) {
					throw response.statusText;
				}
				return response;
			}).then(function (response) {
				return response.json();
			}).catch(function (e) {
				return console.error(e);
			});
		}
	}, {
		key: 'fetchCSV',
		value: function fetchCSV(url) {
			return (0, _getCsv2.default)(url);
		}
	}, {
		key: 'getAccounts',
		value: function getAccounts() {
			var type = arguments.length <= 0 || arguments[0] === undefined ? 'publisher' : arguments[0];

			return this.fetchJson('https://api.awin.com/accounts?type=' + type);
		}
	}, {
		key: 'getProgrammes',
		value: function getProgrammes(_ref2) {
			var account = _ref2.account;
			var _ref2$relationship = _ref2.relationship;
			var relationship = _ref2$relationship === undefined ? 'joined' : _ref2$relationship;

			return this.fetchJson('https://api.awin.com/publishers/' + account + '/programmes?relationship=' + relationship);
		}
	}, {
		key: 'getProgrammeDetail',
		value: function getProgrammeDetail(_ref3) {
			var account = _ref3.account;
			var advertiserId = _ref3.advertiserId;

			return this.fetchJson('https://api.awin.com/publishers/' + account + '/programmedetails?advertiserId=' + advertiserId);
		}
	}, {
		key: 'getProgrammeDetails',
		value: function getProgrammeDetails(_ref4) {
			var _this = this;

			var account = _ref4.account;
			var _ref4$relationship = _ref4.relationship;
			var relationship = _ref4$relationship === undefined ? 'joined' : _ref4$relationship;

			return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
				var programmes, programmeIds, promises;
				return _regenerator2.default.wrap(function _callee$(_context) {
					while (1) {
						switch (_context.prev = _context.next) {
							case 0:
								_context.next = 2;
								return _this.getProgrammes({ account: account, relationship: relationship });

							case 2:
								programmes = _context.sent;
								programmeIds = programmes.map(function (programme) {
									return programme.id;
								});
								promises = programmeIds.map(function (advertiserId) {
									return _this.getProgrammeDetail({ account: account, advertiserId: advertiserId });
								});
								_context.next = 7;
								return _promise2.default.all(promises);

							case 7:
								return _context.abrupt('return', _context.sent);

							case 8:
							case 'end':
								return _context.stop();
						}
					}
				}, _callee, _this);
			}))();
		}
	}, {
		key: 'getCommissionGroup',
		value: function getCommissionGroup(_ref6) {
			var account = _ref6.account;
			var advertiserId = _ref6.advertiserId;
			var commissionGroup = _ref6.commissionGroup;

			var urlExtra = advertiserId ? '?advertiserId=' + advertiserId : '/' + commissionGroup;
			return this.fetchJson('https://api.awin.com/publishers/' + account + '/commissiongroups' + urlExtra);
		}
	}, {
		key: 'getProgrammeAndCommissionGroups',
		value: function getProgrammeAndCommissionGroups(_ref7) {
			var _this2 = this;

			var account = _ref7.account;
			var _ref7$relationship = _ref7.relationship;
			var relationship = _ref7$relationship === undefined ? 'joined' : _ref7$relationship;

			return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
				var programmes, programmeIds, promises, results;
				return _regenerator2.default.wrap(function _callee2$(_context2) {
					while (1) {
						switch (_context2.prev = _context2.next) {
							case 0:
								_context2.next = 2;
								return _this2.getProgrammes({ account: account, relationship: relationship });

							case 2:
								programmes = _context2.sent;
								programmeIds = programmes.map(function (programme) {
									return programme.id;
								});
								promises = programmeIds.map(function (advertiserId) {
									return _this2.getCommissionGroup({ account: account, advertiserId: advertiserId });
								});
								_context2.next = 7;
								return _promise2.default.all(promises);

							case 7:
								results = _context2.sent;
								return _context2.abrupt('return', results.map(function (result, index) {
									return (0, _assign2.default)({}, programmes[index], result);
								}));

							case 9:
							case 'end':
								return _context2.stop();
						}
					}
				}, _callee2, _this2);
			}))();
		}

		// By default, gets most recent year's transactions

	}, {
		key: 'getTransactions',
		value: function getTransactions(_ref9) {
			var _this3 = this;

			var account = _ref9.account;
			var _ref9$startDate = _ref9.startDate;
			var startDate = _ref9$startDate === undefined ? new Date().add(-1, 'years') : _ref9$startDate;
			var _ref9$endDate = _ref9.endDate;
			var endDate = _ref9$endDate === undefined ? new Date() : _ref9$endDate;
			var _ref9$dateType = _ref9.dateType;
			var dateType = _ref9$dateType === undefined ? 'transaction' : _ref9$dateType;
			var _ref9$timezone = _ref9.timezone;
			var timezone = _ref9$timezone === undefined ? 'UTC' : _ref9$timezone;

			return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
				var dateRangeInDays, daysInRange, numberOfDayRanges, promises, results;
				return _regenerator2.default.wrap(function _callee3$(_context3) {
					while (1) {
						switch (_context3.prev = _context3.next) {
							case 0:
								dateRangeInDays = (endDate - startDate) / (1000 * 60 * 60 * 24);
								daysInRange = 31;
								numberOfDayRanges = Math.ceil(dateRangeInDays / daysInRange);

								promises = function () {
									var index = 0;
									var promises = [];
									for (; index < numberOfDayRanges; index = index + 1) {
										var startDateToUse = new Date(startDate.getTime()).add(daysInRange * index, 'days');
										var endDateToUse = new Date(startDate.getTime()).add(daysInRange * (index + 1), 'days');
										if (endDateToUse > endDate) {
											endDateToUse = endDate;
										}
										promises.push(_this3.fetchJson('https://api.awin.com/publishers/' + account + '/transactions/?startDate=' + encodeURIComponent(startDateToUse.format('YYYY-MM-DDThh:mm:ss')) + '&endDate=' + encodeURIComponent(endDateToUse.format('YYYY-MM-DDThh:mm:ss')) + '&dateType=' + dateType + '&timezone=' + timezone));
									}
									return promises;
								}();

								_context3.next = 6;
								return _promise2.default.all(promises);

							case 6:
								results = _context3.sent;
								return _context3.abrupt('return', results.reduce(function (prev, curr) {
									return prev.concat(curr);
								}, []));

							case 8:
							case 'end':
								return _context3.stop();
						}
					}
				}, _callee3, _this3);
			}))();
		}
	}, {
		key: 'getVouchers',
		value: function getVouchers(_ref11) {
			var _this4 = this;

			var account = _ref11.account;
			var promotionsId = _ref11.promotionsId;

			return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4() {
				var csv;
				return _regenerator2.default.wrap(function _callee4$(_context4) {
					while (1) {
						switch (_context4.prev = _context4.next) {
							case 0:
								_context4.next = 2;
								return _this4.fetchCSV('https://ui.awin.com/export-promotions/' + account + '/' + promotionsId + '?promotionType=voucher&categoryIds=&regionIds=&advertiserIds=&membershipStatus=joined&promotionStatus=');

							case 2:
								csv = _context4.sent;
								return _context4.abrupt('return', csv.map(function (voucher) {
									return {
										id: voucher['Promotion ID'],
										advertiserId: voucher['Advertiser ID'],
										code: voucher.Code,
										description: voucher.Description,
										url: voucher['Deeplink Tracking'],
										startDate: voucher.Starts.date("YYYY-MM-DD hh:mm:ss"),
										endDate: voucher.Ends.date("YYYY-MM-DD hh:mm:ss")
									};
								}));

							case 4:
							case 'end':
								return _context4.stop();
						}
					}
				}, _callee4, _this4);
			}))();
		}
	}]);
	return Awin;
}(); /* eslint-disable no-console */

exports.default = Awin;